Summary: Plug-ins for spAudio 
Name: spPlugin
Version: 0.8.6
Release: 3
License: distributable
Distribution: (none)
Vendor: (none)
Group: System Environment/Libraries
Source: %{name}-%{version}-%{release}.tgz
URL: http://www-ie.meijo-u.ac.jp/labs/rj001/spLibs/index.html
BuildRoot: %{_tmppath}/%{name}-%{version}-root
Requires: libogg, libvorbis, libsndfile, flac, pulseaudio-libs
BuildRequires: findutils, libogg-devel, libvorbis-devel, libsndfile-devel, flac-devel, pulseaudio-libs-devel, git, spBase >= 0.8.24, spAudio >= 0.7.16
%define __spec_install_post /usr/lib/rpm/brp-compress || :
%define _binaries_in_noarch_packages_terminate_build 0

%description 
This is a collection of plug-ins for spAudio I/O.
This package includes a powerful command-line sound player "spplay"
which uses spPlugin.

%package android
Summary: spPlugin plug-in collection for Android development
BuildArch: noarch
%description android
This package includes spPlugin plug-in collection for Android development.

%changelog
* Wed May 29 2024  Hideki Banno 
- Version 0.8.6-3

* Fri Apr 21 2023  Hideki Banno
- Version 0.8.6-2

* Wed Mar 22 2023  Hideki Banno
- Version 0.8.6-1

* Sun Apr 14 2019  Hideki Banno
- Version 0.8.5-5

* Tue Nov 20 2018  Hideki Banno
- Version 0.8.5-4

* Sun Nov 20 2016  Hideki Banno 
- Version 0.8.5-3

* Mon May 16 2016  Hideki Banno
- Version 0.8.5-2

* Wed Aug 20 2014  Hideki Banno
- Version 0.8.5

* Mon Sep  3 2012  Hideki Banno
- Version 0.8.4

* Sun Feb 17 2002  Hideki Banno
- Version 0.8.3

* Sun Jul  1 2001  Hideki Banno
- Version 0.8.2-2

* Sat Feb 24 2001  Hideki Banno
- Version 0.8.2

* Sun Oct  8 2000  Hideki Banno
- Version 0.8.1

* Tue Aug 15 2000  Hideki Banno
- 1st release

%prep
%setup -q
%{__rm} -rf %{buildroot}
%{__mkdir_p} %{buildroot}%{_prefix}
%{__mkdir_p} %{buildroot}%{_bindir}
cd spPlugin/input_alac
if [ -d %{_sourcedir}/ALAC ]; then
    cp -pdr %{_sourcedir}/ALAC .
else
    #svn checkout http://svn.macosforge.org/repository/alac/trunk ALAC
    git clone https://github.com/macosforge/alac.git ALAC
fi
cd ../..
cd spPlugin/monkey
%define MAC_SDK %(if [ -f %{_sourcedir}/MAC_1073_SDK.zip ]; then echo 1; else echo 0; fi)
%if %{MAC_SDK}
    unzip %{_sourcedir}/MAC_1073_SDK.zip -d MAC
    cp -pd MAC/Source/MACLib/*.h MAC/
    cp -pd MAC/Source/Shared/*.h MAC/
    sed -i.bak -E 's~    if\(__get_cpuid_count\(level, 0, \&cpuInfo\[0\], \&cpuInfo\[1\], \&cpuInfo\[2\], \&cpuInfo\[3\]\) == 0\)~#if __GNUC__ < 7\r\n    int levelfail;\r\n    int maxlevel = __get_cpuid_max\(level \& 0x80000000, 0\);\r\n    levelfail = \(maxlevel == 0 || maxlevel < level\);\r\n    if\(!levelfail\) {\r\n        __cpuid_count\(level, 0, cpuInfo\[0\], cpuInfo\[1\], cpuInfo\[2\], cpuInfo\[3\]\);\r\n        return true;\r\n    } else\r\n#else\r\n    if\(__get_cpuid_count\(level, 0, \&cpuInfo\[0\], \&cpuInfo\[1\], \&cpuInfo\[2\], \&cpuInfo\[3\]\) == 0\)\r\n#endif~g' MAC/Source/Shared/CPUFeatures.cpp
%endif
cd ../..

%build
%define debug_package %{nil}
cd spPlugin
%{__make} TOP=%{_prefix} SPLIBDIRNAME=%{_lib} clean
%{__make} TOP=%{_prefix} SPLIBDIRNAME=%{_lib}
cd ..

%install
%{__mkdir_p} %{buildroot}%{_datadir}/sp/spPlugin
cd spPlugin
%{__make} TOP=%{_prefix} SPLIBDIRNAME=%{_lib} PLUGINDEST="" SPDESTROOT=%{buildroot}%{_prefix} install
%{__make} TOP=%{_prefix} SPLIBDIRNAME=%{_lib} DEST="" SPDESTROOT=%{buildroot}%{_prefix} install.bin
%{__make} TOP=%{_prefix} SPLIBDIRNAME=%{_lib} DEST="" SPDESTROOT=%{buildroot}%{_prefix} SPMANDEST=%{buildroot}%{_mandir}/man1 install.man
for dir in `ls -1`; do
    if [ -d "${dir}" -a -d "${dir}/android/libs" ] ; then
	%{__mkdir_p} %{buildroot}%{_datadir}/sp/spPlugin/${dir}/android
	cp -r ${dir}/android/libs %{buildroot}%{_datadir}/sp/spPlugin/${dir}/android/
    elif [ -d "${dir}" -a -d "${dir}/android-input/libs" ] ; then
	%{__mkdir_p} %{buildroot}%{_datadir}/sp/spPlugin/input_${dir}/android
	cp -r ${dir}/android-input/libs %{buildroot}%{_datadir}/sp/spPlugin/input_${dir}/android/
    elif [ -d "${dir}" -a -d "${dir}/android-output/libs" ] ; then
	%{__mkdir_p} %{buildroot}%{_datadir}/sp/spPlugin/output_${dir}/android
	cp -r ${dir}/android-output/libs %{buildroot}%{_datadir}/sp/spPlugin/output_${dir}/android/
    fi
done
cd ..
%{__strip} --remove-section=.comment --remove-section=.note --strip-debug %{buildroot}%{_libdir}/sp/plugins/*.so
%{__strip} --remove-section=.comment --remove-section=.note --strip-debug %{buildroot}%{_bindir}/*

%clean
%{__rm} -rf %{buildroot}

%pre
%post

%preun
%postun

%files 
%defattr(-,root,root)
%doc spPlugin/README* spPlugin/CHANGES* spPlugin/LICENSE*
%doc %{_mandir}/man1/*
%{_libdir}/sp/plugins/*
%defattr(755,root,root)
%{_bindir}/*

%files android
%defattr(-,root,root)
%{_datadir}/sp/spPlugin/
